﻿using UnityEngine;
using HarmonyLib;
using System.Reflection;
public class TidyHouse : Mod
{
    private const string playerPrefsSpawnRadiusKey = "mod-tidyhouse-fallenspawnradius";
    public static int fallenSpawnRadius = 30;
    private static Harmony mHarmony;
    public void Start()
    {
        if (PlayerPrefs.HasKey(playerPrefsSpawnRadiusKey))
        {
            fallenSpawnRadius = PlayerPrefs.GetInt(playerPrefsSpawnRadiusKey);
            Debug.Log("Mod TidyHouse has been loaded!");
            Debug.Log("Configured fallen item spawn radius is " + fallenSpawnRadius.ToString());
        }
        else
        {
            fallenSpawnRadius = 30;
            PlayerPrefs.SetInt(playerPrefsSpawnRadiusKey, 30);
            Debug.Log("Mod TidyHouse has been loaded!");
            Debug.Log("Fallen item spawn radius has been set to the default of " + fallenSpawnRadius.ToString());
        }
        mHarmony = new Harmony("nl.nikku.tidyhouse");
        mHarmony.PatchAll(Assembly.GetExecutingAssembly());
    }

    [ConsoleCommand("setfallenspawnradius", "Allows you to define a radius (in meters) around a fireplace where sticks/rocks won't spawn.  Example:  setfallenspawnradius 30")]
    public static void Setfallenspawnradius(string[] args)
    {
        if (args.Length == 1)
        {
            try
            {
                int radius = int.Parse(args[0]);
                PlayerPrefs.SetInt(playerPrefsSpawnRadiusKey, radius);
                fallenSpawnRadius = radius;
                Debug.Log("Fallen item spawn radius has been set to: " + radius.ToString());
            }
            catch
            {
                Debug.LogWarning("Incorrect syntax! Syntax : setfallenspawnradius <radius>");
                return;
            }
        }
        else
        {
            Debug.LogWarning("Incorrect syntax! Syntax : setfallenspawnradius <radius>");
        }
    }

    public void OnModUnload()
    {
        mHarmony.UnpatchAll("nl.nikku.tidyhouse");
        Debug.Log("Mod TidyHouse has been unloaded!");
    }
}

[HarmonyPatch(typeof(FallenObjectsManager))]
[HarmonyPatch("CreateFallenObjects")]
internal class Patch_CreateFallenObjects
{
    public static bool Prefix(GameObject go)
    {
        for (int i = 0; i < Firecamp.s_Firecamps.Count; i++)
        {
            int distance = (int)Firecamp.s_Firecamps[i].transform.position.Distance(go.transform.position);

            if (distance < TidyHouse.fallenSpawnRadius)
            {
                return false; // Fallen object will not be created
            }
        }
        return true;
    }
}